"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const inquirer_1 = require("inquirer");
const is_git_url_1 = __importDefault(require("is-git-url"));
const is_valid_path_1 = __importDefault(require("is-valid-path"));
const questions = [
    {
        type: "input",
        name: "name",
        message: "template name",
        validate: function (val) {
            if (!val) {
                return "template name can't be empty";
            }
            else {
                return true;
            }
        },
    },
    {
        type: "input",
        name: "description",
        message: "template description",
    },
    {
        type: "input",
        name: "templatePath",
        message: "template address/path",
        validate: function (val) {
            if (!val) {
                return "template path can't be empty";
            }
            else if ((0, is_valid_path_1.default)(val)) {
                return true;
            }
            else {
                return "invalid path/git address";
            }
        },
    },
    {
        type: "input",
        name: "branch",
        message: "git branch name",
        when: function (answers) {
            return (0, is_git_url_1.default)(answers.templatePath);
        },
    },
];
async function default_1() {
    const tpls = (0, utils_1.getTemplateRecords)();
    const data = await (0, inquirer_1.prompt)(questions);
    const tplInfo = Object.assign({}, data);
    if ((0, is_git_url_1.default)(tplInfo.templatePath) && !tplInfo.branch) {
        tplInfo.branch = "master";
    }
    data.templatePath = data.templatePath.trim();
    tpls[data.name] = tplInfo;
    (0, utils_1.updateTemplateData)(tpls);
}
exports.default = default_1;
