"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const child_process_1 = require("child_process");
const utils_1 = require("../utils");
const is_git_url_1 = __importDefault(require("is-git-url"));
const is_valid_path_1 = __importDefault(require("is-valid-path"));
const download_1 = __importDefault(require("download"));
const is_local_path_1 = __importDefault(require("is-local-path"));
const tmp_1 = __importDefault(require("tmp"));
const inquirer_1 = __importDefault(require("inquirer"));
const logger_1 = __importDefault(require("../logger"));
function save(file) {
    try {
        let config = fs.readJsonSync(file);
        inquirer_1.default
            .prompt([
            {
                type: "confirm",
                name: "yes",
                message: "Are you sure to overwrite your template config",
            },
        ])
            .then(({ yes }) => {
            if (yes) {
                (0, utils_1.updateTemplateData)(config);
            }
        });
    }
    catch (err) {
        throw new Error(err);
    }
}
async function default_1(tplConfigPath) {
    if (!(0, is_valid_path_1.default)(tplConfigPath)) {
        throw new Error("invalid config path");
    }
    else if ((0, is_local_path_1.default)(tplConfigPath)) {
        tplConfigPath = path_1.default.resolve(tplConfigPath);
        if (!fs.existsSync(tplConfigPath)) {
            throw new Error("un-found config file");
        }
        save(tplConfigPath);
    }
    else if ((0, is_git_url_1.default)(tplConfigPath)) {
        let tmpDir = tmp_1.default.dirSync().name;
        (0, child_process_1.execSync)(`git clone --quiet ${tplConfigPath} ${tmpDir}`);
        let configFilePath = path_1.default.join(tmpDir, "template.json");
        if (fs.existsSync(configFilePath)) {
            save(configFilePath);
        }
        else {
            logger_1.default.error(`failed to find ${configFilePath}, please make sure it exists`);
        }
    }
    else {
        let tmpFile = tmp_1.default.fileSync().name;
        fs.writeFileSync(tmpFile, await (0, download_1.default)(tplConfigPath));
        save(tmpFile);
    }
}
exports.default = default_1;
