"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const picocolors_1 = __importDefault(require("picocolors"));
const prefix = 'inix';
const loggerFormat = function (level, label) {
    return function (message) {
        var colors = {
            info: "white",
            warn: "yellowBright",
            error: "redBright",
            success: "green",
        };
        const color = colors[level];
        console.log(`[${picocolors_1.default.gray(label)}] ${picocolors_1.default[color](level)}: ${picocolors_1.default[color](message)}`);
    };
};
const logger = {
    info: loggerFormat("info", prefix),
    warn: loggerFormat("warn", prefix),
    error: loggerFormat("error", prefix),
    success: loggerFormat("success", prefix),
};
const log = logger.info;
const info = log;
const warn = logger.warn;
const error = function (msg) {
    logger.error(picocolors_1.default.red(JSON.stringify(msg)));
};
const fatal = error;
const success = logger.success;
exports.default = { log, info, warn, error, fatal, success };
